This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 809425 - Bugs found in python-bibtex-1.2.5-4.fc17 using gcc-with-cpychecker static analyzer
Bugs found in python-bibtex-1.2.5-4.fc17 using gcc-with-cpychecker static ana...
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: python-bibtex (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Zoltan Kota
Fedora Extras Quality Assurance
http://fedorapeople.org/~dmalcolm/gcc...
:
Depends On:
Blocks: cpychecker
  Show dependency treegraph
 
Reported: 2012-04-03 06:43 EDT by Dave Malcolm
Modified: 2014-04-29 09:08 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-04-29 09:08:18 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Dave Malcolm 2012-04-03 06:43:52 EDT
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
python-bibtex-1.2.5-4.fc17.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-04-03/python-bibtex-1.2.5-4.fc17/

I've manually reviewed the issues reported by the tool.

Within the category "Reference leaks" the 2 issues reported appear to be genuine bugs:
  bibtexmodule.c:bib_reverse:ob_refcnt of '*authobj' is 1 too high: missing Py_XDECREF, I think.
  bibtexmodule.c:_bib_next:ob_refcnt of '*name' is 1 too high: should use code "N" to Py_BuildValue, not code "O"

Within the category "Segfaults within error-handling paths" the 11 issues reported appear to be genuine crashers under low-memory conditions, where a function returns NULL and the code doesn't check for that.

Within the category "Returning (PyObject*)NULL without setting an exception" the 5 issues reported appear to be false-positives

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
python-bibtex-1.2.5-4.fc17
gcc-python-plugin post-0.9 git d578ee0e46d93647d0f94502784f890c38139d60 running the checker in an *f16* chroot
Comment 1 Fedora End Of Life 2013-04-03 14:06:26 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 2 Zoltan Kota 2014-04-29 09:08:18 EDT
The upstream maintainer updated the code to fix issues reported here. So, I'm closing this bug for now. The update comes as python-bibtex-1.2.7-1.fc21 in rawhide.

Note You need to log in before you can comment on or make changes to this bug.